# coding: utf-8

"""
    Subscriptions

    Subscriptions allow contacts to control what forms of communications they receive. Contacts can decide whether they want to receive communication pertaining to a specific topic, brand, or an entire HubSpot account.  # noqa: E501

    The version of the OpenAPI document: v3
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from hubspot.communication_preferences.configuration import Configuration


class SubscriptionDefinitionsResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"subscription_definitions": "list[SubscriptionDefinition]"}

    attribute_map = {"subscription_definitions": "subscriptionDefinitions"}

    def __init__(self, subscription_definitions=None, local_vars_configuration=None):  # noqa: E501
        """SubscriptionDefinitionsResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._subscription_definitions = None
        self.discriminator = None

        self.subscription_definitions = subscription_definitions

    @property
    def subscription_definitions(self):
        """Gets the subscription_definitions of this SubscriptionDefinitionsResponse.  # noqa: E501

        A list of all subscription definitions.  # noqa: E501

        :return: The subscription_definitions of this SubscriptionDefinitionsResponse.  # noqa: E501
        :rtype: list[SubscriptionDefinition]
        """
        return self._subscription_definitions

    @subscription_definitions.setter
    def subscription_definitions(self, subscription_definitions):
        """Sets the subscription_definitions of this SubscriptionDefinitionsResponse.

        A list of all subscription definitions.  # noqa: E501

        :param subscription_definitions: The subscription_definitions of this SubscriptionDefinitionsResponse.  # noqa: E501
        :type: list[SubscriptionDefinition]
        """
        if self.local_vars_configuration.client_side_validation and subscription_definitions is None:  # noqa: E501
            raise ValueError("Invalid value for `subscription_definitions`, must not be `None`")  # noqa: E501

        self._subscription_definitions = subscription_definitions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item, value.items()))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SubscriptionDefinitionsResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SubscriptionDefinitionsResponse):
            return True

        return self.to_dict() != other.to_dict()
